/*-----------------------------------------------------------------------
 t2.c - test fossil program.
------------------------------------------------------------------------*/
#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <dos.h>

void FOSSinit(int);
void FOSSputc(int, unsigned char);
int FOSSgetc(int);
unsigned int FOSSstatus(int);
unsigned int FOSSbaud(int, unsigned char);
void FOSSflowCtrl(int, unsigned char);
#define CTRL_XONXOFF 9
#define CTRL_RTSCTS  2
#define PORT         4


void main(void)
{
	int c;

	FOSSinit(PORT);
	FOSSbaud(PORT, 0x23);	// 38400,N,8,1
	FOSSflowCtrl(PORT, CTRL_XONXOFF | CTRL_RTSCTS);

	while (1)
	{
		if (getchar() == 3)
			break;

		while (FOSSstatus(PORT) & 1)
		{	c= FOSSgetc(PORT);
			putchar(c);
		}
	}
}

void FOSSinit(int port)
{
asm	mov dx,port
asm	mov ah,4
asm	int 0x14
}

unsigned int FOSSbaud(int port, unsigned char baud)
{
asm	mov dx,port
asm	mov al,baud
asm	mov ah,0
asm	int 0x14

	return(_AX);
}

void FOSSputc(int port, unsigned char c)
{
asm	mov dx,port
asm	mov al,c
asm	mov ah,1
asm	int 0x14
}

int FOSSgetc(int port)
{
asm	mov dx,port
asm	mov ah,2
asm	int 0x14

	return(_AX);
}

unsigned int FOSSstatus(int port)
{
asm	mov dx,port
asm	mov ah,3
asm	int 0x14

	return(_AX);
}

void FOSSflowCtrl(int port, unsigned char mode)
{
asm	mov dx,port
asm	mov al, mode
asm	mov ah, 0x0f
asm	int 0x14
}

